; reloc.asm
; relocation module

BITS 32
CPU 386

SECTION '.text'

find_reloc:
	;int		03h
	push	ebp
	mov		ebp, esp

	pushad
	
	mov		esi, dword [ebp+08h]
	add		esi, dword [esi+03ch]
	lea		esi, [esi+0a0h]
	
	push	dword [esi+04h]
	push	dword [esi]
	mov		eax, dword [ebp+08h]
	add		dword [esp], eax
	push	dword [ebp+08h]
	call	scan_reloc
	
	popad
		
	mov		esp, ebp
	pop		ebp
	ret		04h

; Scanning of relocation table
; Parameters:
;	ebp+08	= Base Address
;	ebp+0c	= Pointer to reloc table
;	ebp+10	= Size
scan_reloc:
	push	ebp
	mov		ebp, esp
	sub		esp, 20h
	
	pushad
	
	mov		ecx, dword [ebp+10h]
	mov		esi, dword [ebp+0ch]

@1:
	test	ecx, ecx
	jz		@10
	
	mov		eax, dword [esi]
	add		eax, dword [ebp+08]
	
	push	dword [esi+04h]		; Dimension
	push	esi					; Addr.
	push	eax					; Start Page Table
	push	dword [ebp+08h]		; Base Addr.
	call	reloc_page
	
	sub		ecx, [esi+04h]
	add		esi, [esi+04h]
	
	jmp		@1
@10:
	xor		eax, eax
	
	popad

	mov		esp, ebp
	pop		ebp
	ret		0ch


reloc_page:
	push	ebp
	mov		ebp, esp
	sub		esp, 20h
	
	mov		eax, dword [ebp+08h]
	add		eax, dword [eax+3ch]
	
	mov		eax, dword [eax+34h]
	
	push	eax
	mov		eax, dword [ebp+08h]
	sub		eax, dword [esp]
	add		esp, 4	; skip pop!
	mov		dword [ebp-04h], eax	; EBP-04 = difference
	
	push	ecx
	push	esi
	push	edi
	
	mov		esi, dword [ebp+10h]
	mov		edi, dword [ebp+0ch]
	mov		ecx, dword [ebp+14h]
	add		esi, 8
	test	ecx, ecx
	jz		@20
	sub		ecx, 8
	
@2:	
	test	ecx, ecx
	jz		@20
	
	push	edi
	xor		eax, eax
	mov		ax, word [esi]
	and		ax, 0fffh		; only 12 bit!
	add		edi, eax
	mov		ax, word [esi]
	and		ax, 0f000h
	shr		ax, 0ch
	cmp		ax, 03h
	jne		@21
	
	mov		eax, dword [ebp-04h]	; reloc IMAGE_REL_BASED_HIGHLOW!
	add		dword [edi], eax		; reloc it!
		
@21:
	sub		ecx, 2
	pop		edi
	add		esi, 2
	jmp		@2
@20:

	pop		edi
	pop		esi
	pop		ecx
	mov		esp, ebp
	pop		ebp
	ret		10h
	